Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynkeg.F90	(revision 2633)
@@ -51,5 +51,5 @@
       !!             - save this trends (l_trddyn=T) for post-processing
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY:   wrk_use, wrk_release
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE oce     , ONLY:   ztrdu => ta       , ztrdv => sa   ! (ta,sa) used as 3D workspace   
       USE wrk_nemo, ONLY:   zhke  => wrk_3d_1                 ! 3D workspace
@@ -61,5 +61,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(3,1) ) THEN
+      IF(wrk_in_use(3,1) ) THEN
          CALL ctl_stop('dyn_key: requested workspace array is unavailable.')   ;   RETURN
       ENDIF
@@ -135,5 +135,5 @@
          &                       tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
       !
-      IF(.NOT. wrk_release(3, 1) )   CALL ctl_stop('dyn_key: failed to release workspace array')
+      IF(wrk_not_released(3, 1) )   CALL ctl_stop('dyn_key: failed to release workspace array')
       !
    END SUBROUTINE dyn_keg
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf.F90	(revision 2633)
@@ -52,5 +52,5 @@
       !! ** Purpose :   compute the lateral ocean dynamics physics.
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: ztrdu => wrk_3d_1, ztrdv => wrk_3d_2
       !!
@@ -58,5 +58,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(3, 1,2))THEN
+      IF(wrk_in_use(3, 1,2))THEN
          CALL ctl_stop('dyn_ldf: requested workspace arrays unavailable.')
          RETURN
@@ -112,5 +112,5 @@
          &                       tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
       !
-      IF(.NOT. wrk_release(3, 1,2))THEN
+      IF(wrk_not_released(3, 1,2))THEN
          CALL ctl_stop('dyn_ldf: failed to release workspace arrays.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilap.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilap.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilap.F90	(revision 2633)
@@ -75,5 +75,5 @@
       !!               mixing trend.
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: zcu => wrk_2d_1, zcv => wrk_2d_2   ! 3D workspace
       USE wrk_nemo, ONLY: zuf => wrk_3d_1, zut => wrk_3d_2   ! 3D workspace
@@ -86,5 +86,5 @@
       !!----------------------------------------------------------------------
 
-      IF( .NOT. wrk_use(2, 1,2) .OR. .NOT. wrk_use(3, 1,2,3,4) ) THEN
+      IF( wrk_in_use(2, 1,2) .OR. wrk_in_use(3, 1,2,3,4) ) THEN
          CALL ctl_stop('dyn_ldf_bilap : requested workspace arrays unavailable')   ;   RETURN
       ENDIF
@@ -208,6 +208,6 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-      IF( .NOT. wrk_release(2, 1,2)      .OR.   &
-          .NOT. wrk_release(3, 1,2,3,4) )   CALL ctl_stop('dyn_ldf_bilap : failed to release workspace arrays')
+      IF( wrk_not_released(2, 1,2)      .OR.   &
+          wrk_not_released(3, 1,2,3,4) )   CALL ctl_stop('dyn_ldf_bilap : failed to release workspace arrays')
       !
    END SUBROUTINE dyn_ldf_bilap
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilapg.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilapg.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_bilapg.F90	(revision 2633)
@@ -86,5 +86,5 @@
       !!              - save the trend in (zwk3,zwk4) ('key_trddyn')
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY:   wrk_use, wrk_release
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   zwk1 => wrk_3d_1 , zwk2 => wrk_3d_2   ! 3D workspace
       USE oce     , ONLY:   zwk3 => ta       , zwk4 => sa         ! ta, sa used as 3D workspace   
@@ -95,5 +95,5 @@
       !!----------------------------------------------------------------------
 
-      IF( .NOT. wrk_use(3, 1,2) ) THEN
+      IF( wrk_in_use(3, 1,2) ) THEN
          CALL ctl_stop('dyn_ldf_bilapg: requested workspace arrays unavailable.')   ;   RETURN
       END IF
@@ -131,5 +131,5 @@
       END DO
       !
-      IF( .NOT. wrk_release(3, 1,2) )   CALL ctl_stop('dyn_ldf_bilapg: failed to release workspace arrays')
+      IF( wrk_not_released(3, 1,2) )   CALL ctl_stop('dyn_ldf_bilapg: failed to release workspace arrays')
       !
    END SUBROUTINE dyn_ldf_bilapg
@@ -177,5 +177,5 @@
       !!      'key_trddyn' defined: the trend is saved for diagnostics.
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: ziut => wrk_2d_1, zjuf => wrk_2d_2, zjvt => wrk_2d_3
       USE wrk_nemo, ONLY: zivf => wrk_2d_4, zdku => wrk_2d_5, zdk1u => wrk_2d_6
@@ -196,5 +196,5 @@
       !!----------------------------------------------------------------------
 
-      IF( .NOT. wrk_use(2, 1,2,3,4,5,6,7,8) ) THEN
+      IF( wrk_in_use(2, 1,2,3,4,5,6,7,8) ) THEN
          CALL ctl_stop('dyn:ldfguv : requested workspace arrays unavailable.')   ;   RETURN
       END IF
@@ -454,5 +454,5 @@
       !                                                ! ===============
 
-      IF(.NOT. wrk_release(2, 1,2,3,4,5,6,7,8))THEN
+      IF(wrk_not_released(2, 1,2,3,4,5,6,7,8))THEN
          CALL ctl_stop('dyn:ldfguv : failed to release workspace arrays.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_iso.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_iso.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynldf_iso.F90	(revision 2633)
@@ -106,5 +106,5 @@
       !!      of the rotated operator in dynzdf module
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY:   wrk_use, wrk_release
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   ziut  => wrk_2d_1 , zjuf  => wrk_2d_2 , zjvt => wrk_2d_3    ! 2D workspace
       USE wrk_nemo, ONLY:   zivf  => wrk_2d_4 , zdku  => wrk_2d_5 , zdkv => wrk_2d_6    ! 2D workspace
@@ -120,5 +120,5 @@
       !!----------------------------------------------------------------------
 
-      IF( .NOT. wrk_use(2, 1,2,3,4,5,6,7,8) ) THEN
+      IF( wrk_in_use(2, 1,2,3,4,5,6,7,8) ) THEN
          CALL ctl_stop('dyn_ldf_iso: requested workspace arrays unavailable.')   ;   RETURN
       END IF
@@ -429,5 +429,5 @@
       !                                                ! ===============
 
-      IF( .NOT. wrk_release(2, 1,2,3,4,5,6,7,8))THEN
+      IF( wrk_not_released(2, 1,2,3,4,5,6,7,8))THEN
          CALL ctl_stop('dyn_ldf_iso: failed to release workspace arrays.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 2633)
@@ -93,5 +93,5 @@
       USE oce, ONLY :   ze3u_f => ta   ! use ta as 3D workspace
       USE oce, ONLY :   ze3v_f => sa   ! use sa as 3D workspace
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   zs_t => wrk_2d_1, zs_u_1 => wrk_2d_2, &
                           zs_v_1 => wrk_2d_3
@@ -110,5 +110,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(2, 1,2,3))THEN
+      IF(wrk_in_use(2, 1,2,3))THEN
          CALL ctl_stop('dyn_nxt: requested workspace arrays unavailable.')
          RETURN
@@ -325,5 +325,5 @@
          &                       tab3d_2=vn, clinfo2=' Vn: '       , mask2=vmask )
       ! 
-      IF(.NOT. wrk_release(2, 1,2,3))THEN
+      IF(wrk_not_released(2, 1,2,3))THEN
          CALL ctl_stop('dyn_nxt: failed to release workspace arrays.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg.F90	(revision 2633)
@@ -73,5 +73,5 @@
       !!        of the physical meaning of the results. 
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: ztrdu => wrk_3d_4, ztrdv => wrk_3d_5
       !!
@@ -83,5 +83,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(3, 4,5))THEN
+      IF(wrk_in_use(3, 4,5))THEN
          CALL ctl_stop('dyn_spg: requested workspace arrays unavailable.')
          RETURN
@@ -154,5 +154,5 @@
          &                       tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
       !
-      IF(.NOT. wrk_release(3, 4,5))THEN
+      IF(wrk_not_released(3, 4,5))THEN
          CALL ctl_stop('dyn_spg: failed to release workspace arrays.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 2633)
@@ -111,5 +111,5 @@
       !! References : Griffies et al., (2003): A technical guide to MOM4. NOAA/GFDL
       !!---------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: zhdiv => wrk_2d_1, zsshb_e => wrk_2d_2
       USE wrk_nemo, ONLY: zbfru => wrk_2d_3  , zbfrv => wrk_2d_4 
@@ -132,5 +132,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(2,  1, 2, 3, 4, 5, 6, 7, 8, 9,10,         &
+      IF(wrk_in_use(2,  1, 2, 3, 4, 5, 6, 7, 8, 9,10,         &
                           11,12,13,14,15,16,17,18,19,20,21 ) ) THEN
          CALL ctl_stop( 'dyn_spg_ts: requested workspace arrays unavailable.' )   ;   RETURN
@@ -569,5 +569,5 @@
       !
       !
-      IF(.NOT. wrk_release(2,  1, 2, 3, 4, 5, 6, 7, 8, 9,10,         &
+      IF(wrk_not_released(2,  1, 2, 3, 4, 5, 6, 7, 8, 9,10,         &
                               11,12,13,14,15,16,17,18,19,20,21))THEN
          CALL ctl_stop('dyn_spg_ts: failed to release workspace arrays.')
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynvor.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynvor.F90	(revision 2633)
@@ -204,5 +204,5 @@
       !! References : Sadourny, r., 1975, j. atmos. sciences, 32, 680-689.
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: zwx => wrk_2d_1, zwy => wrk_2d_2, zwz => wrk_2d_3
       !!
@@ -218,5 +218,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(2, 1,2,3))THEN
+      IF(wrk_in_use(2, 1,2,3))THEN
          CALL ctl_stop('dyn:vor_ene: requested workspace arrays unavailable.')
          RETURN
@@ -286,5 +286,5 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-      IF(.NOT. wrk_release(2, 1,2,3))THEN
+      IF(wrk_not_released(2, 1,2,3))THEN
          CALL ctl_stop('dyn:vor_ene: failed to release workspace arrays.')
       END IF
@@ -324,5 +324,5 @@
       !! References : Sadourny, r., 1975, j. atmos. sciences, 32, 680-689.
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: zwx => wrk_2d_4, zwy => wrk_2d_5, &
                           zwz => wrk_2d_6, zww => wrk_2d_7
@@ -335,5 +335,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(2, 4,5,6,7))THEN
+      IF(wrk_in_use(2, 4,5,6,7))THEN
          CALL ctl_stop('dyn:vor_mix: requested workspace arrays unavailable.')
          RETURN
@@ -410,5 +410,5 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-      IF(.NOT. wrk_release(2, 4,5,6,7))THEN
+      IF(wrk_not_released(2, 4,5,6,7))THEN
          CALL ctl_stop('dyn:vor_mix: failed to release workspace arrays.')
       END IF
@@ -443,5 +443,5 @@
       !! References : Sadourny, r., 1975, j. atmos. sciences, 32, 680-689.
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: zwx => wrk_2d_4, zwy => wrk_2d_5, zwz => wrk_2d_6
       !!
@@ -456,5 +456,5 @@
       !!----------------------------------------------------------------------
       
-      IF(.NOT. wrk_use(2, 4,5,6))THEN
+      IF(wrk_in_use(2, 4,5,6))THEN
          CALL ctl_stop('dyn:vor_ens : requested workspace arrays unavailable.')
          RETURN
@@ -532,5 +532,5 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-      IF(.NOT. wrk_release(2, 4,5,6))THEN
+      IF(wrk_not_released(2, 4,5,6))THEN
          CALL ctl_stop('dyn:vor_ens : failed to release workspace arrays.')
       END IF
@@ -558,5 +558,5 @@
       !! References : Arakawa and Lamb 1980, Mon. Wea. Rev., 109, 18-36
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY:   wrk_use, wrk_release
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   zwx  => wrk_2d_1 , zwy  => wrk_2d_2 ,  zwz => wrk_2d_3 
       USE wrk_nemo, ONLY:   ztnw => wrk_2d_4 , ztne => wrk_2d_5 
@@ -580,5 +580,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(2, 1,2,3,4,5,6,7) .AND. .NOT. wrk_use(3, 1) ) THEN
+      IF(wrk_in_use(2, 1,2,3,4,5,6,7) .OR. wrk_in_use(3, 1) ) THEN
          CALL ctl_stop('dyn:vor_een : requested workspace arrays unavailable.')   ;   RETURN
       END IF
@@ -681,6 +681,6 @@
       END DO                                           !   End of slab
       !                                                ! ===============
-      IF(.NOT. wrk_release(2, 1,2,3,4,5,6,7) .AND.   &
-         .NOT. wrk_release(3, 1)  )   CALL ctl_stop('dyn:vor_een : failed to release workspace arrays')
+      IF(wrk_not_released(2, 1,2,3,4,5,6,7) .OR.   &
+         wrk_not_released(3, 1)  )   CALL ctl_stop('dyn:vor_een : failed to release workspace arrays')
       !
    END SUBROUTINE vor_een
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzad.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzad.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzad.F90	(revision 2633)
@@ -56,5 +56,5 @@
       USE oce, ONLY:   zwuw => ta   ! use ta as 3D workspace
       USE oce, ONLY:   zwvw => sa   ! use sa as 3D workspace
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: zww => wrk_2d_1
       USE wrk_nemo, ONLY: ztrdu => wrk_3d_1, ztrdv => wrk_3d_2
@@ -66,6 +66,6 @@
       !!----------------------------------------------------------------------
       
-      IF( (.NOT. wrk_use(2, 1))  .OR.    &
-          (.NOT. wrk_use(3, 1,2)) )THEN
+      IF( wrk_in_use(2, 1)  .OR.    &
+          wrk_in_use(3, 1,2) )THEN
          CALL ctl_stop('dyn_zad: requested workspace arrays unavailable.')
          RETURN
@@ -126,6 +126,6 @@
          &                       tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
       !
-      IF( (.NOT. wrk_release(2, 1))  .OR.    &
-          (.NOT. wrk_release(3, 1,2)) )THEN
+      IF( wrk_not_released(2, 1)  .OR.    &
+          wrk_not_released(3, 1,2) )THEN
          CALL ctl_stop('dyn_zad: failed to release workspace arrays.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf.F90	(revision 2633)
@@ -52,5 +52,5 @@
       !! ** Purpose :   compute the vertical ocean dynamics physics.
       !!---------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: ztrdu => wrk_3d_1, ztrdv => wrk_3d_2
       !!
@@ -58,5 +58,5 @@
       !!---------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(3, 1,2))THEN
+      IF(wrk_in_use(3, 1,2))THEN
          CALL ctl_stop('dyn_zdf: requested workspace arrays unavailable.')
          RETURN
@@ -95,5 +95,5 @@
             &                    tab3d_2=va, clinfo2=       ' Va: ', mask2=vmask, clinfo3='dyn' )
       !
-      IF(.NOT. wrk_release(3, 1,2))THEN
+      IF(wrk_not_released(3, 1,2))THEN
          CALL ctl_stop('dyn_zdf: failed to release workspace arrays.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_exp.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_exp.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_exp.F90	(revision 2633)
@@ -52,7 +52,7 @@
       !! ** Action : - Update (ua,va) with the vertical diffusive trend
       !!---------------------------------------------------------------------
-      USE wrk_nemo, ONLY:   wrk_use, wrk_release
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE oce     , ONLY :  zwx => ta       , zwy => sa         ! (ta,sa) used as 3D workspace
-      USE wrk_nemo, ONLY:   zwz => wrk_3d_1 , zww => wrk_3d_1   ! 3D workspace
+      USE wrk_nemo, ONLY:   zwz => wrk_3d_1 , zww => wrk_3d_2   ! 3D workspace
       !
       INTEGER , INTENT(in) ::   kt     ! ocean time-step index
@@ -62,4 +62,9 @@
       REAL(wp) ::   zrau0r, zlavmr, zua, zva                 ! temporary scalars
       !!----------------------------------------------------------------------
+
+      IF( wrk_in_use(3, 1,2) )THEN
+         CALL ctl_stop('dyn_zdf_exp : requested workspace arrays unavailable.')
+         RETURN
+      END IF
 
       IF( kt == nit000 .AND. lwp ) THEN
@@ -114,4 +119,8 @@
       END DO                           ! End of time splitting
       !
+      IF( wrk_not_released(3, 1,2) )THEN
+         CALL ctl_stop('dyn_zdf_exp : failed to release workspace arrays.')
+      END IF
+      !
    END SUBROUTINE dyn_zdf_exp
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/dynzdf_imp.F90	(revision 2633)
@@ -56,5 +56,5 @@
       USE oce, ONLY :  zwd   => ta      ! use ta as workspace
       USE oce, ONLY :  zws   => sa      ! use sa as workspace
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: zwi => wrk_3d_3 ! workspace
       !!
@@ -67,5 +67,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(3, 3))THEN
+      IF(wrk_in_use(3, 3))THEN
          CALL ctl_stop('dyn_zdf_imp : requested workspace array unavailable.')
          RETURN
@@ -259,5 +259,5 @@
       END DO
       !
-      IF(.NOT. wrk_release(3, 3))THEN
+      IF(wrk_not_released(3, 3))THEN
          CALL ctl_stop('dyn_zdf_imp : failed to release workspace array.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 2633)
@@ -76,5 +76,5 @@
       !!----------------------------------------------------------------------
       USE oce, ONLY :   z3d => ta   ! use ta as 3D workspace
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: zhdiv => wrk_2d_1, z2d => wrk_2d_2
       !!
@@ -86,5 +86,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(2, 1,2))THEN
+      IF(wrk_in_use(2, 1,2))THEN
          CALL ctl_stop('ssh_wzv: requested workspace arrays unavailable.')
          RETURN
@@ -244,5 +244,5 @@
       IF(ln_ctl)   CALL prt_ctl( tab2d_1=ssha, clinfo1=' ssha  - : ', mask1=tmask, ovlap=1 )
       !
-      IF(.NOT. wrk_release(2, 1,2))THEN
+      IF(wrk_not_released(2, 1,2))THEN
          CALL ctl_stop('ssh_wzv: failed to release workspace arrays.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/IOM/prtctl.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/IOM/prtctl.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/IOM/prtctl.F90	(revision 2633)
@@ -78,5 +78,5 @@
       !!   9.0  !  05-07  (C. Talandier) original code
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: ztab2d_1 => wrk_2d_1, ztab2d_2 => wrk_2d_2
       USE wrk_nemo, ONLY:   zmask1 => wrk_3d_1,   zmask2 => wrk_3d_2, &
@@ -101,5 +101,5 @@
       !!----------------------------------------------------------------------
 
-      IF( (.NOT. wrk_use(2, 1,2)) .OR. (.NOT. wrk_use(3, 1,2,3,4)) )THEN
+      IF( wrk_in_use(2, 1,2) .OR. wrk_in_use(3, 1,2,3,4) )THEN
          CALL ctl_stop('prt_ctl : requested workspace arrays unavailable.')
          RETURN
@@ -213,5 +213,5 @@
       ENDDO
 
-      IF( (.NOT. wrk_release(2, 1,2)) .OR. (.NOT. wrk_release(3, 1,2,3,4)) )THEN
+      IF( wrk_not_released(2, 1,2) .OR. wrk_not_released(3, 1,2,3,4) )THEN
          CALL ctl_stop('prt_ctl : failed to release workspace arrays.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LBC/lib_mpp.F90	(revision 2633)
@@ -1726,5 +1726,5 @@
       !!
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY:   wrk_use, wrk_release
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY:   ztab => wrk_2d_1
       !
@@ -1746,5 +1746,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.NOT. wrk_use(2, 1) ) THEN
+      IF(wrk_in_use(2, 1) ) THEN
          WRITE(kumout, cform_err)
          WRITE(kumout,*) 'mppobc : requested workspace array unavailable'
@@ -1901,5 +1901,5 @@
       END DO
       !
-      IF(.NOT. wrk_release(2, 1) ) THEN
+      IF(wrk_not_released(2, 1) ) THEN
          WRITE(kumout, cform_err)
          WRITE(kumout,*) 'mppobc : failed to release workspace array'
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c2d.h90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c2d.h90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c2d.h90	(revision 2633)
@@ -145,5 +145,5 @@
       !! * Modules used
       USE ldftra_oce, ONLY : aht0
-      USE wrk_nemo, ONLY: iwrk_use, iwrk_release
+      USE wrk_nemo, ONLY: iwrk_in_use, iwrk_not_released
       USE wrk_nemo, ONLY: icof => iwrk_2d_1
       !! * Arguments
@@ -162,5 +162,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.not. iwrk_use(2, 1))THEN
+      IF( iwrk_in_use(2, 1) )THEN
          CALL ctl_stop('ldf_dyn_c2d_orca: ERROR: requested workspace array is unavailable.')
          RETURN
@@ -293,5 +293,5 @@
       ENDIF
 
-      IF(.not. iwrk_release(2, 1))THEN
+      IF( iwrk_not_released(2, 1) )THEN
          CALL ctl_stop('ldf_dyn_c2d_orca: ERROR: failed to release workspace array.')
       END IF
@@ -316,5 +316,5 @@
       !! * Modules used
       USE ldftra_oce, ONLY : aht0
-      USE wrk_nemo, ONLY: iwrk_use, iwrk_release
+      USE wrk_nemo, ONLY: iwrk_in_use, iwrk_not_released
       USE wrk_nemo, ONLY: icof => iwrk_2d_1
 
@@ -334,5 +334,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.not. iwrk_use(2, 1))THEN
+      IF( iwrk_in_use(2, 1) )THEN
          CALL ctl_stop('ldf_dyn_c2d_orca_R1: ERROR: requested workspace array is unavailable.')
          RETURN
@@ -472,5 +472,5 @@
       ENDIF
 
-      IF(.not. iwrk_release(2, 1))THEN
+      IF( iwrk_not_released(2, 1) )THEN
          CALL ctl_stop('ldf_dyn_c2d_orca_R1: ERROR: failed to release workspace array.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90	(revision 2633)
@@ -27,5 +27,5 @@
       !!----------------------------------------------------------------------
       USE ldftra_oce, ONLY : aht0
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: zcoef => wrk_1d_2
       !!
@@ -44,5 +44,5 @@
       !!----------------------------------------------------------------------
 
-      IF(.not. wrk_use(1,2))THEN
+      IF(wrk_in_use(1,2))THEN
          CALL ctl_stop('ldf_dyn_c3d: ERROR: requested workspace array unavailable.')
          RETURN
@@ -188,5 +188,5 @@
       ENDIF
 
-      IF(.not. wrk_release(1,2))THEN
+      IF(wrk_not_released(1,2))THEN
          CALL ctl_stop('ldf_dyn_c3d: ERROR: failed to release workspace array.')
       END IF
@@ -204,5 +204,5 @@
       !!----------------------------------------------------------------------
       USE ldftra_oce, ONLY : aht0
-      USE wrk_nemo, ONLY: wrk_use, wrk_release, iwrk_use, iwrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released, iwrk_in_use, iwrk_not_released
       USE wrk_nemo, ONLY:  icof => iwrk_2d_1
       USE wrk_nemo, ONLY: zahm0 =>  wrk_2d_1
@@ -225,6 +225,5 @@
       !!----------------------------------------------------------------------
 
-      IF( (.not. iwrk_use(2,1)) .OR. (.not. wrk_use(2,1)) .OR. &
-          (.not. wrk_use(1,1)))THEN
+      IF( iwrk_in_use(2,1) .OR. wrk_in_use(2,1) .OR. wrk_in_use(1,1) )THEN
          CALL ctl_stop('ldf_dyn_c3d_orca: ERROR: requested workspace arrays are unavailable.')
          RETURN
@@ -474,6 +473,6 @@
       ENDIF
 
-      IF( (.not. iwrk_release(2,1)) .OR. (.not. wrk_release(2,1)) .OR. &
-          (.not. wrk_release(1,1)))THEN
+      IF( iwrk_not_released(2,1) .OR. wrk_not_released(2,1) .OR. &
+           wrk_not_released(1,1) )THEN
          CALL ctl_stop('ldf_dyn_c3d_orca: ERROR: failed to release workspace arrays.')
       END IF
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv.F90	(revision 2632)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/OPA_SRC/LDF/ldfeiv.F90	(revision 2633)
@@ -53,5 +53,5 @@
       !!             - wslpi, wslpj : i- and j-slopes of neutral surfaces at w-points. 
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY: wrk_use, wrk_release
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
       USE wrk_nemo, ONLY: zn  => wrk_2d_1, zah   => wrk_2d_2, &
                           zhw => wrk_2d_3, zross => wrk_2d_4
@@ -63,5 +63,5 @@
       !!----------------------------------------------------------------------
       
-      IF(.not. wrk_use(2, 1,2,3,4))THEN
+      IF(wrk_in_use(2, 1,2,3,4))THEN
          CALL ctl_stop('ldf_eiv: ERROR: requested workspace arrays are unavailable.')
          RETURN
@@ -244,5 +244,5 @@
       CALL iom_put( "aht2d_eiv", aeiw )   ! EIV lateral eddy diffusivity
       !  
-      IF(.not. wrk_release(2, 1,2,3,4))THEN
+      IF(wrk_not_released(2, 1,2,3,4))THEN
          CALL ctl_stop('ldf_eiv: ERROR: failed to release workspace arrays.')
       END IF
